Index: /pjproject/trunk/pjlib/src/pj/ssl_sock_ossl.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ssl_sock_ossl.c	(revision 5937)
+++ /pjproject/trunk/pjlib/src/pj/ssl_sock_ossl.c	(revision 5938)
@@ -32,5 +32,4 @@
 #include <pj/timer.h>
 
-
 /* Only build when PJ_HAS_SSL_SOCK is enabled and when the backend is
  * OpenSSL.
@@ -39,10 +38,8 @@
     (PJ_SSL_SOCK_IMP == PJ_SSL_SOCK_IMP_OPENSSL)
 
+#include "ssl_sock_imp_common.h"
+#include "ssl_sock_imp_common.c"
+
 #define THIS_FILE		"ssl_sock_ossl.c"
-
-/* Workaround for ticket #985 and #1930 */
-#ifndef PJ_SSL_SOCK_DELAYED_CLOSE_TIMEOUT
-#   define PJ_SSL_SOCK_DELAYED_CLOSE_TIMEOUT	500
-#endif
 
 /* 
@@ -164,116 +161,9 @@
 
 /*
- * SSL/TLS state enumeration.
- */
-enum ssl_state {
-    SSL_STATE_NULL,
-    SSL_STATE_HANDSHAKING,
-    SSL_STATE_ESTABLISHED,
-    SSL_STATE_ERROR
-};
-
-/*
- * Internal timer types.
- */
-enum timer_id
-{
-    TIMER_NONE,
-    TIMER_HANDSHAKE_TIMEOUT,
-    TIMER_CLOSE
-};
-
-/*
- * Structure of SSL socket read buffer.
- */
-typedef struct read_data_t
-{
-    void		 *data;
-    pj_size_t		  len;
-} read_data_t;
-
-/*
- * Get the offset of pointer to read-buffer of SSL socket from read-buffer
- * of active socket. Note that both SSL socket and active socket employ 
- * different but correlated read-buffers (as much as async_cnt for each),
- * and to make it easier/faster to find corresponding SSL socket's read-buffer
- * from known active socket's read-buffer, the pointer of corresponding 
- * SSL socket's read-buffer is stored right after the end of active socket's
- * read-buffer.
- */
-#define OFFSET_OF_READ_DATA_PTR(ssock, asock_rbuf) \
-					(read_data_t**) \
-					((pj_int8_t*)(asock_rbuf) + \
-					ssock->param.read_buffer_size)
-
-/*
- * Structure of SSL socket write data.
- */
-typedef struct write_data_t {
-    PJ_DECL_LIST_MEMBER(struct write_data_t);
-    pj_ioqueue_op_key_t	 key;
-    pj_size_t 	 	 record_len;
-    pj_ioqueue_op_key_t	*app_key;
-    pj_size_t 	 	 plain_data_len;
-    pj_size_t 	 	 data_len;
-    unsigned		 flags;
-    union {
-	char		 content[1];
-	const char	*ptr;
-    } data;
-} write_data_t;
-
-/*
- * Structure of SSL socket write buffer (circular buffer).
- */
-typedef struct send_buf_t {
-    char		*buf;
-    pj_size_t		 max_len;    
-    char		*start;
-    pj_size_t		 len;
-} send_buf_t;
-
-/*
  * Secure socket structure definition.
  */
-struct pj_ssl_sock_t
-{
-    pj_pool_t		 *pool;
-    pj_ssl_sock_t	 *parent;
-    pj_ssl_sock_param	  param;
-    pj_ssl_sock_param	  newsock_param;
-    pj_ssl_cert_t	 *cert;
-    
-    pj_ssl_cert_info	  local_cert_info;
-    pj_ssl_cert_info	  remote_cert_info;
-
-    pj_bool_t		  is_server;
-    enum ssl_state	  ssl_state;
-    pj_ioqueue_op_key_t	  handshake_op_key;
-    pj_timer_entry	  timer;
-    pj_status_t		  verify_status;
-
-    unsigned long	  last_err;
-
-    pj_sock_t		  sock;
-    pj_activesock_t	 *asock;
-
-    pj_sockaddr		  local_addr;
-    pj_sockaddr		  rem_addr;
-    int			  addr_len;
-    
-    pj_bool_t		  read_started;
-    pj_size_t		  read_size;
-    pj_uint32_t		  read_flags;
-    void		**asock_rbuf;
-    read_data_t		 *ssock_rbuf;
-
-    write_data_t	  write_pending;/* list of pending write to OpenSSL */
-    write_data_t	  write_pending_empty; /* cache for write_pending   */
-    pj_bool_t		  flushing_write_pend; /* flag of flushing is ongoing*/
-    send_buf_t		  send_buf;
-    write_data_t 	  send_buf_pending; /* send buffer is full but some
-					     * data is queuing in wbio.     */
-    write_data_t	  send_pending;	/* list of pending write to network */
-    pj_lock_t		 *write_mutex;	/* protect write BIO and send_buf   */
+typedef struct ossl_sock_t
+{
+    pj_ssl_sock_t  	  base;
 
     SSL_CTX		 *ossl_ctx;
@@ -281,34 +171,5 @@
     BIO			 *ossl_rbio;
     BIO			 *ossl_wbio;
-};
-
-
-/*
- * Certificate/credential structure definition.
- */
-struct pj_ssl_cert_t
-{
-    pj_str_t CA_file;
-    pj_str_t CA_path;
-    pj_str_t cert_file;
-    pj_str_t privkey_file;
-    pj_str_t privkey_pass;
-
-    /* Certificate buffer. */
-    pj_ssl_cert_buffer CA_buf;
-    pj_ssl_cert_buffer cert_buf;
-    pj_ssl_cert_buffer privkey_buf;
-};
-
-
-static write_data_t* alloc_send_data(pj_ssl_sock_t *ssock, pj_size_t len);
-static void free_send_data(pj_ssl_sock_t *ssock, write_data_t *wdata);
-static pj_status_t flush_delayed_send(pj_ssl_sock_t *ssock);
-
-/*
- *******************************************************************
- * Static/internal functions.
- *******************************************************************
- */
+} ossl_sock_t;
 
 /**
@@ -520,20 +381,54 @@
 
 
+/*
+ *******************************************************************
+ * I/O functions.
+ *******************************************************************
+ */
+
+static pj_bool_t io_empty(pj_ssl_sock_t *ssock, circ_buf_t *cb)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+
+    return !BIO_pending(ossock->ossl_wbio);
+}
+
+static pj_size_t io_size(pj_ssl_sock_t *ssock, circ_buf_t *cb)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+    char *data;
+
+    return BIO_get_mem_data(ossock->ossl_wbio, &data);
+}
+
+static void io_read(pj_ssl_sock_t *ssock, circ_buf_t *cb,
+		    pj_uint8_t *dst, pj_size_t len)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+    char *data;
+
+    BIO_get_mem_data(ossock->ossl_wbio, &data);
+    pj_memcpy(dst, data, len);
+
+    /* Reset write BIO */
+    (void)BIO_reset(ossock->ossl_wbio);
+}
+
+static pj_status_t io_write(pj_ssl_sock_t *ssock, circ_buf_t *cb,
+                            const pj_uint8_t *src, pj_size_t len)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+    int nwritten;
+
+    nwritten = BIO_write(ossock->ossl_rbio, src, (int)len);
+    return (nwritten < (int)len)? GET_SSL_STATUS(cb->owner): PJ_SUCCESS;
+}
+
+/*
+ *******************************************************************
+ */
+
 /* OpenSSL library initialization counter */
 static int openssl_init_count;
-
-/* OpenSSL available ciphers */
-static unsigned openssl_cipher_num;
-static struct openssl_ciphers_t {
-    pj_ssl_cipher    id;
-    const char	    *name;
-} openssl_ciphers[PJ_SSL_SOCK_MAX_CIPHERS];
-
-/* OpenSSL available curves */
-static unsigned openssl_curves_num;
-static struct openssl_curves_t {
-    pj_ssl_curve    id;
-    const char	    *name;
-} openssl_curves[PJ_SSL_SOCK_MAX_CURVES];
 
 /* OpenSSL application data index */
@@ -570,5 +465,5 @@
 
     /* Init available ciphers */
-    if (openssl_cipher_num == 0 || openssl_curves_num == 0) {
+    if (ssl_cipher_num == 0 || ssl_curves_num == 0) {
 	SSL_METHOD *meth = NULL;
 	SSL_CTX *ctx;
@@ -609,16 +504,16 @@
 
 	n = sk_SSL_CIPHER_num(sk_cipher);
-	if (n > PJ_ARRAY_SIZE(openssl_ciphers))
-	    n = PJ_ARRAY_SIZE(openssl_ciphers);
+	if (n > PJ_ARRAY_SIZE(ssl_ciphers))
+	    n = PJ_ARRAY_SIZE(ssl_ciphers);
 
 	for (i = 0; i < n; ++i) {
 	    const SSL_CIPHER *c;
 	    c = sk_SSL_CIPHER_value(sk_cipher,i);
-	    openssl_ciphers[i].id = (pj_ssl_cipher)
+	    ssl_ciphers[i].id = (pj_ssl_cipher)
 				    (pj_uint32_t)SSL_CIPHER_get_id(c) &
 				    0x00FFFFFF;
-	    openssl_ciphers[i].name = SSL_CIPHER_get_name(c);
-	}
-	openssl_cipher_num = n;
+	    ssl_ciphers[i].name = SSL_CIPHER_get_name(c);
+	}
+	ssl_cipher_num = n;
 
 	SSL_set_session(ssl, SSL_SESSION_new());
@@ -626,9 +521,9 @@
 #if !USING_LIBRESSL && !defined(OPENSSL_NO_EC) \
     && OPENSSL_VERSION_NUMBER >= 0x1000200fL
-	openssl_curves_num = SSL_get_shared_curve(ssl,-1);
-	if (openssl_curves_num > PJ_ARRAY_SIZE(openssl_curves))
-	    openssl_curves_num = PJ_ARRAY_SIZE(openssl_curves);
-
-	for (i = 0; i < openssl_curves_num; i++) {
+	ssl_curves_num = SSL_get_shared_curve(ssl,-1);
+	if (ssl_curves_num > PJ_ARRAY_SIZE(ssl_curves))
+	    ssl_curves_num = PJ_ARRAY_SIZE(ssl_curves);
+
+	for (i = 0; i < ssl_curves_num; i++) {
 	    nid = SSL_get_shared_curve(ssl, i);
 
@@ -642,11 +537,11 @@
 	    }
 
-	    openssl_curves[i].id   = get_cid_from_nid(nid);
-	    openssl_curves[i].name = cname;
+	    ssl_curves[i].id   = get_cid_from_nid(nid);
+	    ssl_curves[i].name = cname;
 	}
 #else
 	PJ_UNUSED_ARG(nid);
 	PJ_UNUSED_ARG(cname);
-	openssl_curves_num = 0;
+	ssl_curves_num = 0;
 #endif
 
@@ -788,7 +683,15 @@
 static void set_entropy(pj_ssl_sock_t *ssock);
 
+
+static pj_ssl_sock_t *ssl_alloc(pj_pool_t *pool)
+{
+    return (pj_ssl_sock_t *)PJ_POOL_ZALLOC_T(pool, ossl_sock_t);
+}
+
+
 /* Create and initialize new SSL context and instance */
-static pj_status_t create_ssl(pj_ssl_sock_t *ssock)
-{
+static pj_status_t ssl_create(pj_ssl_sock_t *ssock)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
 #if !defined(OPENSSL_NO_DH)
     BIO *bio;
@@ -1142,12 +1045,12 @@
 
     /* Create SSL instance */
-    ssock->ossl_ctx = ctx;
-    ssock->ossl_ssl = SSL_new(ssock->ossl_ctx);
-    if (ssock->ossl_ssl == NULL) {
+    ossock->ossl_ctx = ctx;
+    ossock->ossl_ssl = SSL_new(ossock->ossl_ctx);
+    if (ossock->ossl_ssl == NULL) {
 	return GET_SSL_STATUS(ssock);
     }
 
     /* Set SSL sock as application data of SSL instance */
-    SSL_set_ex_data(ssock->ossl_ssl, sslsock_idx, ssock);
+    SSL_set_ex_data(ossock->ossl_ssl, sslsock_idx, ssock);
 
     /* SSL verification options */
@@ -1156,5 +1059,5 @@
 	mode |= SSL_VERIFY_FAIL_IF_NO_PEER_CERT;
 
-    SSL_set_verify(ssock->ossl_ssl, mode, &verify_cb);
+    SSL_set_verify(ossock->ossl_ssl, mode, &verify_cb);
 
     /* Set cipher list */
@@ -1174,9 +1077,9 @@
 
     /* Setup SSL BIOs */
-    ssock->ossl_rbio = BIO_new(BIO_s_mem());
-    ssock->ossl_wbio = BIO_new(BIO_s_mem());
-    (void)BIO_set_close(ssock->ossl_rbio, BIO_CLOSE);
-    (void)BIO_set_close(ssock->ossl_wbio, BIO_CLOSE);
-    SSL_set_bio(ssock->ossl_ssl, ssock->ossl_rbio, ssock->ossl_wbio);
+    ossock->ossl_rbio = BIO_new(BIO_s_mem());
+    ossock->ossl_wbio = BIO_new(BIO_s_mem());
+    (void)BIO_set_close(ossock->ossl_rbio, BIO_CLOSE);
+    (void)BIO_set_close(ossock->ossl_wbio, BIO_CLOSE);
+    SSL_set_bio(ossock->ossl_ssl, ossock->ossl_rbio, ossock->ossl_wbio);
 
     return PJ_SUCCESS;
@@ -1185,8 +1088,10 @@
 
 /* Destroy SSL context and instance */
-static void destroy_ssl(pj_ssl_sock_t *ssock)
-{
+static void ssl_destroy(pj_ssl_sock_t *ssock)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+
     /* Destroy SSL instance */
-    if (ssock->ossl_ssl) {
+    if (ossock->ossl_ssl) {
 	/**
 	 * Avoid calling SSL_shutdown() if handshake wasn't completed.
@@ -1194,15 +1099,15 @@
 	 * SSL handshake, while previous versions always return 0.	 
 	 */
-	if (SSL_in_init(ssock->ossl_ssl) == 0) {
-	    SSL_shutdown(ssock->ossl_ssl);
+	if (SSL_in_init(ossock->ossl_ssl) == 0) {
+	    SSL_shutdown(ossock->ossl_ssl);
 	}   	
-	SSL_free(ssock->ossl_ssl); /* this will also close BIOs */
-	ssock->ossl_ssl = NULL;
+	SSL_free(ossock->ossl_ssl); /* this will also close BIOs */
+	ossock->ossl_ssl = NULL;
     }
 
     /* Destroy SSL context */
-    if (ssock->ossl_ctx) {
-	SSL_CTX_free(ssock->ossl_ctx);
-	ssock->ossl_ctx = NULL;
+    if (ossock->ossl_ctx) {
+	SSL_CTX_free(ossock->ossl_ctx);
+	ossock->ossl_ctx = NULL;
     }
 
@@ -1214,38 +1119,6 @@
 
 
-/* Close sockets */
-static void close_sockets(pj_ssl_sock_t *ssock)
-{
-    pj_activesock_t *asock;
-    pj_sock_t sock;
-
-    /* This can happen when pj_ssl_sock_create() fails. */
-    if (!ssock->write_mutex)
-    	return;
-
-    pj_lock_acquire(ssock->write_mutex);
-    asock = ssock->asock;
-    if (asock) {
-        // Don't set ssock->asock to NULL, as it may trigger assertion in
-        // send operation. This should be safe as active socket will simply
-        // return PJ_EINVALIDOP on any operation if it is already closed.
-        //ssock->asock = NULL;
-        ssock->sock = PJ_INVALID_SOCKET;
-    }
-    sock = ssock->sock;
-    if (sock != PJ_INVALID_SOCKET)
-        ssock->sock = PJ_INVALID_SOCKET;
-    pj_lock_release(ssock->write_mutex);
-
-    if (asock)
-        pj_activesock_close(asock);
-
-    if (sock != PJ_INVALID_SOCKET)
-        pj_sock_close(sock);
-}
-
-
 /* Reset SSL socket state */
-static void reset_ssl_sock_state(pj_ssl_sock_t *ssock)
+static void ssl_reset_sock_state(pj_ssl_sock_t *ssock)
 {
     pj_lock_acquire(ssock->write_mutex);
@@ -1253,5 +1126,5 @@
     pj_lock_release(ssock->write_mutex);
 
-    close_sockets(ssock);
+    ssl_close_sockets(ssock);
 
     /* Upon error, OpenSSL may leave any error description in the thread 
@@ -1265,7 +1138,30 @@
 
 
+static void ssl_ciphers_populate()
+{
+    if (ssl_cipher_num == 0 || ssl_curves_num == 0) {
+	init_openssl();
+	shutdown_openssl();
+    }
+}
+
+static pj_ssl_cipher ssl_get_cipher(pj_ssl_sock_t *ssock)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+    const SSL_CIPHER *cipher;
+
+    /* Current cipher */
+    cipher = SSL_get_current_cipher(ossock->ossl_ssl);
+    if (cipher) {
+	return (SSL_CIPHER_get_id(cipher) & 0x00FFFFFF);
+    } else {
+	return PJ_TLS_UNKNOWN_CIPHER;
+    }
+}
+
 /* Generate cipher list with user preference order in OpenSSL format */
 static pj_status_t set_cipher_list(pj_ssl_sock_t *ssock)
 {
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
     pj_pool_t *tmp_pool = NULL;
     char *buf = NULL;
@@ -1277,5 +1173,5 @@
 
     if (ssock->param.ciphers_num == 0) {
-	ret = SSL_set_cipher_list(ssock->ossl_ssl, PJ_SSL_SOCK_OSSL_CIPHERS);
+	ret = SSL_set_cipher_list(ossock->ossl_ssl, PJ_SSL_SOCK_OSSL_CIPHERS);
     	if (ret < 1) {
 	    return GET_SSL_STATUS(ssock);
@@ -1296,8 +1192,8 @@
 
     /* Set SSL with ALL available ciphers */
-    SSL_set_cipher_list(ssock->ossl_ssl, "ALL:COMPLEMENTOFALL");
+    SSL_set_cipher_list(ossock->ossl_ssl, "ALL:COMPLEMENTOFALL");
 
     /* Generate user specified cipher list in OpenSSL format */
-    sk_cipher = SSL_get_ciphers(ssock->ossl_ssl);
+    sk_cipher = SSL_get_ciphers(ossock->ossl_ssl);
     for (i = 0; i < ssock->param.ciphers_num; ++i) {
 	for (j = 0; j < sk_SSL_CIPHER_num(sk_cipher); ++j) {
@@ -1335,5 +1231,5 @@
 
     /* Finally, set chosen cipher list */
-    ret = SSL_set_cipher_list(ssock->ossl_ssl, buf);
+    ret = SSL_set_cipher_list(ossock->ossl_ssl, buf);
     if (ret < 1) {
 	pj_pool_release(tmp_pool);
@@ -1349,4 +1245,5 @@
 #if !USING_LIBRESSL && !defined(OPENSSL_NO_EC) \
     && OPENSSL_VERSION_NUMBER >= 0x1000200fL
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
     int ret;
     int curves[PJ_SSL_SOCK_MAX_CURVES];
@@ -1360,11 +1257,11 @@
     }
 
-    if( SSL_is_server(ssock->ossl_ssl) ) {
-	ret = SSL_set1_curves(ssock->ossl_ssl, curves,
+    if( SSL_is_server(ossock->ossl_ssl) ) {
+	ret = SSL_set1_curves(ossock->ossl_ssl, curves,
 			      ssock->param.curves_num);
 	if (ret < 1)
 	    return GET_SSL_STATUS(ssock);
     } else {
-	ret = SSL_CTX_set1_curves(ssock->ossl_ctx, curves,
+	ret = SSL_CTX_set1_curves(ossock->ossl_ctx, curves,
 				  ssock->param.curves_num);
 	if (ret < 1)
@@ -1380,12 +1277,13 @@
 {
 #if !USING_LIBRESSL && OPENSSL_VERSION_NUMBER >= 0x1000200fL
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
     int ret;
 
     if (ssock->param.sigalgs.ptr && ssock->param.sigalgs.slen) {
 	if (ssock->is_server) {
-	    ret = SSL_set1_client_sigalgs_list(ssock->ossl_ssl,
+	    ret = SSL_set1_client_sigalgs_list(ossock->ossl_ssl,
 	    				       ssock->param.sigalgs.ptr);
 	} else {
-	    ret = SSL_set1_sigalgs_list(ssock->ossl_ssl,
+	    ret = SSL_set1_sigalgs_list(ossock->ossl_ssl,
 	    				ssock->param.sigalgs.ptr);
 	}
@@ -1654,6 +1552,7 @@
  * called after handshake or renegotiation successfully completed.
  */
-static void update_certs_info(pj_ssl_sock_t *ssock)
-{
+static void ssl_update_certs_info(pj_ssl_sock_t *ssock)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
     X509 *x;
 
@@ -1661,5 +1560,5 @@
 
     /* Active local certificate */
-    x = SSL_get_certificate(ssock->ossl_ssl);
+    x = SSL_get_certificate(ossock->ossl_ssl);
     if (x) {
 	get_cert_info(ssock->pool, &ssock->local_cert_info, x, PJ_FALSE);
@@ -1670,5 +1569,5 @@
 
     /* Active remote certificate */
-    x = SSL_get_peer_certificate(ssock->ossl_ssl);
+    x = SSL_get_peer_certificate(ossock->ossl_ssl);
     if (x) {
 	get_cert_info(ssock->pool, &ssock->remote_cert_info, x, PJ_TRUE);
@@ -1681,299 +1580,4 @@
 
 
-/* When handshake completed:
- * - notify application
- * - if handshake failed, reset SSL state
- * - return PJ_FALSE when SSL socket instance is destroyed by application.
- */
-static pj_bool_t on_handshake_complete(pj_ssl_sock_t *ssock, 
-				       pj_status_t status)
-{
-    /* Cancel handshake timer */
-    if (ssock->timer.id == TIMER_HANDSHAKE_TIMEOUT) {
-	pj_timer_heap_cancel(ssock->param.timer_heap, &ssock->timer);
-	ssock->timer.id = TIMER_NONE;
-    }
-
-    /* Update certificates info on successful handshake */
-    if (status == PJ_SUCCESS)
-	update_certs_info(ssock);
-
-    /* Accepting */
-    if (ssock->is_server) {
-	if (status != PJ_SUCCESS) {
-	    /* Handshake failed in accepting, destroy our self silently. */
-
-	    char errmsg[PJ_ERR_MSG_SIZE];
-	    char buf[PJ_INET6_ADDRSTRLEN+10];
-
-	    pj_strerror(status, errmsg, sizeof(errmsg));
-	    PJ_LOG(3,(ssock->pool->obj_name, "Handshake failed in accepting "
-		      "%s: %s",
-		      pj_sockaddr_print(&ssock->rem_addr, buf, sizeof(buf), 3),
-		      errmsg));
-
-	    if (ssock->param.cb.on_accept_complete2) {
-		(*ssock->param.cb.on_accept_complete2) 
-		      (ssock->parent, ssock, (pj_sockaddr_t*)&ssock->rem_addr, 
-		      pj_sockaddr_get_len((pj_sockaddr_t*)&ssock->rem_addr), 
-		      status);
-	    }
-
-	    /* Originally, this is a workaround for ticket #985. However,
-	     * a race condition may occur in multiple worker threads
-	     * environment when we are destroying SSL objects while other
-	     * threads are still accessing them.
-	     * Please see ticket #1930 for more info.
-	     */
-#if 1 //(defined(PJ_WIN32) && PJ_WIN32!=0)||(defined(PJ_WIN64) && PJ_WIN64!=0)
-	    if (ssock->param.timer_heap) {
-		pj_time_val interval = {0, PJ_SSL_SOCK_DELAYED_CLOSE_TIMEOUT};
-
-		ssock->ssl_state = SSL_STATE_NULL;
-		close_sockets(ssock);
-
-		if (ssock->timer.id != TIMER_NONE) {
-		    pj_timer_heap_cancel(ssock->param.timer_heap,
-					 &ssock->timer);
-		}
-		ssock->timer.id = TIMER_CLOSE;
-		pj_time_val_normalize(&interval);
-		if (pj_timer_heap_schedule(ssock->param.timer_heap, 
-					   &ssock->timer, &interval) != 0)
-		{
-	    	    PJ_LOG(3,(ssock->pool->obj_name, "Failed to schedule "
-		      	      "a delayed close. Race condition may occur."));
-		    ssock->timer.id = TIMER_NONE;
-		    pj_ssl_sock_close(ssock);
-		}
-	    } else {
-		pj_ssl_sock_close(ssock);
-	    }
-#else
-	    {
-		pj_ssl_sock_close(ssock);
-	    }
-#endif
-
-	    return PJ_FALSE;
-	}
-	/* Notify application the newly accepted SSL socket */
-	if (ssock->param.cb.on_accept_complete2) {
-	    pj_bool_t ret;
-	    ret = (*ssock->param.cb.on_accept_complete2) 
-		    (ssock->parent, ssock, (pj_sockaddr_t*)&ssock->rem_addr, 
-		    pj_sockaddr_get_len((pj_sockaddr_t*)&ssock->rem_addr), 
-		    status);
-	    if (ret == PJ_FALSE)
-		return PJ_FALSE;	
-	} else if (ssock->param.cb.on_accept_complete) {
-	    pj_bool_t ret;
-	    ret = (*ssock->param.cb.on_accept_complete)
-		      (ssock->parent, ssock, (pj_sockaddr_t*)&ssock->rem_addr,
-		       pj_sockaddr_get_len((pj_sockaddr_t*)&ssock->rem_addr));
-	    if (ret == PJ_FALSE)
-		return PJ_FALSE;
-	}
-    }
-
-    /* Connecting */
-    else {
-	/* On failure, reset SSL socket state first, as app may try to 
-	 * reconnect in the callback.
-	 */
-	if (status != PJ_SUCCESS) {
-	    /* Server disconnected us, possibly due to SSL nego failure */
-	    if (status == PJ_EEOF) {
-		unsigned long err;
-		err = ERR_get_error();
-		if (err != SSL_ERROR_NONE)
-		    status = STATUS_FROM_SSL_ERR("connecting", ssock, err);
-	    }
-	    reset_ssl_sock_state(ssock);
-	}
-	if (ssock->param.cb.on_connect_complete) {
-	    pj_bool_t ret;
-	    ret = (*ssock->param.cb.on_connect_complete)(ssock, status);
-	    if (ret == PJ_FALSE)
-		return PJ_FALSE;
-	}
-    }
-
-    return PJ_TRUE;
-}
-
-static write_data_t* alloc_send_data(pj_ssl_sock_t *ssock, pj_size_t len)
-{
-    send_buf_t *send_buf = &ssock->send_buf;
-    pj_size_t avail_len, skipped_len = 0;
-    char *reg1, *reg2;
-    pj_size_t reg1_len, reg2_len;
-    write_data_t *p;
-
-    /* Check buffer availability */
-    avail_len = send_buf->max_len - send_buf->len;
-    if (avail_len < len)
-	return NULL;
-
-    /* If buffer empty, reset start pointer and return it */
-    if (send_buf->len == 0) {
-	send_buf->start = send_buf->buf;
-	send_buf->len   = len;
-	p = (write_data_t*)send_buf->start;
-	goto init_send_data;
-    }
-
-    /* Free space may be wrapped/splitted into two regions, so let's
-     * analyze them if any region can hold the write data.
-     */
-    reg1 = send_buf->start + send_buf->len;
-    if (reg1 >= send_buf->buf + send_buf->max_len)
-	reg1 -= send_buf->max_len;
-    reg1_len = send_buf->max_len - send_buf->len;
-    if (reg1 + reg1_len > send_buf->buf + send_buf->max_len) {
-	reg1_len = send_buf->buf + send_buf->max_len - reg1;
-	reg2 = send_buf->buf;
-	reg2_len = send_buf->start - send_buf->buf;
-    } else {
-	reg2 = NULL;
-	reg2_len = 0;
-    }
-
-    /* More buffer availability check, note that the write data must be in
-     * a contigue buffer.
-     */
-    avail_len = PJ_MAX(reg1_len, reg2_len);
-    if (avail_len < len)
-	return NULL;
-
-    /* Get the data slot */
-    if (reg1_len >= len) {
-	p = (write_data_t*)reg1;
-    } else {
-	p = (write_data_t*)reg2;
-	skipped_len = reg1_len;
-    }
-
-    /* Update buffer length */
-    send_buf->len += len + skipped_len;
-
-init_send_data:
-    /* Init the new send data */
-    pj_bzero(p, sizeof(*p));
-    pj_list_init(p);
-    pj_list_push_back(&ssock->send_pending, p);
-
-    return p;
-}
-
-static void free_send_data(pj_ssl_sock_t *ssock, write_data_t *wdata)
-{
-    send_buf_t *buf = &ssock->send_buf;
-    write_data_t *spl = &ssock->send_pending;
-
-    pj_assert(!pj_list_empty(&ssock->send_pending));
-    
-    /* Free slot from the buffer */
-    if (spl->next == wdata && spl->prev == wdata) {
-	/* This is the only data, reset the buffer */
-	buf->start = buf->buf;
-	buf->len = 0;
-    } else if (spl->next == wdata) {
-	/* This is the first data, shift start pointer of the buffer and
-	 * adjust the buffer length.
-	 */
-	buf->start = (char*)wdata->next;
-	if (wdata->next > wdata) {
-	    buf->len -= ((char*)wdata->next - buf->start);
-	} else {
-	    /* Overlapped */
-	    pj_size_t right_len, left_len;
-	    right_len = buf->buf + buf->max_len - (char*)wdata;
-	    left_len  = (char*)wdata->next - buf->buf;
-	    buf->len -= (right_len + left_len);
-	}
-    } else if (spl->prev == wdata) {
-	/* This is the last data, just adjust the buffer length */
-	if (wdata->prev < wdata) {
-	    pj_size_t jump_len;
-	    jump_len = (char*)wdata -
-		       ((char*)wdata->prev + wdata->prev->record_len);
-	    buf->len -= (wdata->record_len + jump_len);
-	} else {
-	    /* Overlapped */
-	    pj_size_t right_len, left_len;
-	    right_len = buf->buf + buf->max_len -
-			((char*)wdata->prev + wdata->prev->record_len);
-	    left_len  = (char*)wdata + wdata->record_len - buf->buf;
-	    buf->len -= (right_len + left_len);
-	}
-    }
-    /* For data in the middle buffer, just do nothing on the buffer. The slot
-     * will be freed later when freeing the first/last data.
-     */
-    
-    /* Remove the data from send pending list */
-    pj_list_erase(wdata);
-}
-
-#if 0
-/* Just for testing send buffer alloc/free */
-#include <pj/rand.h>
-pj_status_t pj_ssl_sock_ossl_test_send_buf(pj_pool_t *pool)
-{
-    enum { MAX_CHUNK_NUM = 20 };
-    unsigned chunk_size, chunk_cnt, i;
-    write_data_t *wdata[MAX_CHUNK_NUM] = {0};
-    pj_time_val now;
-    pj_ssl_sock_t *ssock = NULL;
-    pj_ssl_sock_param param;
-    pj_status_t status;
-
-    pj_gettimeofday(&now);
-    pj_srand((unsigned)now.sec);
-
-    pj_ssl_sock_param_default(&param);
-    status = pj_ssl_sock_create(pool, &param, &ssock);
-    if (status != PJ_SUCCESS) {
-	return status;
-    }
-
-    if (ssock->send_buf.max_len == 0) {
-	ssock->send_buf.buf = (char*)
-			      pj_pool_alloc(ssock->pool, 
-					    ssock->param.send_buffer_size);
-	ssock->send_buf.max_len = ssock->param.send_buffer_size;
-	ssock->send_buf.start = ssock->send_buf.buf;
-	ssock->send_buf.len = 0;
-    }
-
-    chunk_size = ssock->param.send_buffer_size / MAX_CHUNK_NUM / 2;
-    chunk_cnt = 0;
-    for (i = 0; i < MAX_CHUNK_NUM; i++) {
-	wdata[i] = alloc_send_data(ssock, pj_rand() % chunk_size + 321);
-	if (wdata[i])
-	    chunk_cnt++;
-	else
-	    break;
-    }
-
-    while (chunk_cnt) {
-	i = pj_rand() % MAX_CHUNK_NUM;
-	if (wdata[i]) {
-	    free_send_data(ssock, wdata[i]);
-	    wdata[i] = NULL;
-	    chunk_cnt--;
-	}
-    }
-
-    if (ssock->send_buf.len != 0)
-	status = PJ_EBUG;
-
-    pj_ssl_sock_close(ssock);
-    return status;
-}
-#endif
-
-
 /* Flush write BIO to network socket. Note that any access to write BIO
  * MUST be serialized, so mutex protection must cover any call to OpenSSL
@@ -1982,119 +1586,46 @@
  * OpenSSL API call).
  */
-static pj_status_t flush_write_bio(pj_ssl_sock_t *ssock, 
-				   pj_ioqueue_op_key_t *send_key,
-				   pj_size_t orig_len,
-				   unsigned flags)
-{
-    char *data;
-    pj_ssize_t len;
-    write_data_t *wdata;
-    pj_size_t needed_len;
-    pj_status_t status;
-
-    pj_lock_acquire(ssock->write_mutex);
-
-    /* Check if there is data in write BIO, flush it if any */
-    if (!BIO_pending(ssock->ossl_wbio)) {
-	pj_lock_release(ssock->write_mutex);
-	return PJ_SUCCESS;
-    }
-
-    /* Get data and its length */
-    len = BIO_get_mem_data(ssock->ossl_wbio, &data);
-    if (len == 0) {
-	pj_lock_release(ssock->write_mutex);
-	return PJ_SUCCESS;
-    }
-
-    /* Calculate buffer size needed, and align it to 8 */
-    needed_len = len + sizeof(write_data_t);
-    needed_len = ((needed_len + 7) >> 3) << 3;
-
-    /* Allocate buffer for send data */
-    wdata = alloc_send_data(ssock, needed_len);
-    if (wdata == NULL) {
-	/* Oops, write BIO is ready but the send buffer is full, let's just
-	 * queue it for sending and return PJ_EPENDING.
-	 */
-	ssock->send_buf_pending.data_len = needed_len;
-	ssock->send_buf_pending.app_key = send_key;
-	ssock->send_buf_pending.flags = flags;
-	ssock->send_buf_pending.plain_data_len = orig_len;
-	pj_lock_release(ssock->write_mutex);
-	return PJ_EPENDING;
-    }
-
-    /* Copy the data and set its properties into the send data */
-    pj_ioqueue_op_key_init(&wdata->key, sizeof(pj_ioqueue_op_key_t));
-    wdata->key.user_data = wdata;
-    wdata->app_key = send_key;
-    wdata->record_len = needed_len;
-    wdata->data_len = len;
-    wdata->plain_data_len = orig_len;
-    wdata->flags = flags;
-    pj_memcpy(&wdata->data, data, len);
-
-    /* Reset write BIO */
-    (void)BIO_reset(ssock->ossl_wbio);
-
-    /* Ticket #1573: Don't hold mutex while calling PJLIB socket send(). */
-    pj_lock_release(ssock->write_mutex);
-
-    /* Send it */
-    if (ssock->param.sock_type == pj_SOCK_STREAM()) {
-	status = pj_activesock_send(ssock->asock, &wdata->key, 
-				    wdata->data.content, &len,
-				    flags);
+static pj_status_t flush_circ_buf_output(pj_ssl_sock_t *ssock,
+                                         pj_ioqueue_op_key_t *send_key,
+                                         pj_size_t orig_len, unsigned flags);
+
+
+static void ssl_set_state(pj_ssl_sock_t *ssock, pj_bool_t is_server)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+    if (is_server) {
+        SSL_set_accept_state(ossock->ossl_ssl);
     } else {
-	status = pj_activesock_sendto(ssock->asock, &wdata->key, 
-				      wdata->data.content, &len,
-				      flags,
-				      (pj_sockaddr_t*)&ssock->rem_addr,
-				      ssock->addr_len);
-    }
-
-    if (status != PJ_EPENDING) {
-	/* When the sending is not pending, remove the wdata from send
-	 * pending list.
-	 */
-	pj_lock_acquire(ssock->write_mutex);
-	free_send_data(ssock, wdata);
-	pj_lock_release(ssock->write_mutex);
-    }
-
-    return status;
-}
-
-
-static void on_timer(pj_timer_heap_t *th, struct pj_timer_entry *te)
-{
-    pj_ssl_sock_t *ssock = (pj_ssl_sock_t*)te->user_data;
-    int timer_id = te->id;
-
-    te->id = TIMER_NONE;
-
-    PJ_UNUSED_ARG(th);
-
-    switch (timer_id) {
-    case TIMER_HANDSHAKE_TIMEOUT:
-	PJ_LOG(1,(ssock->pool->obj_name, "SSL timeout after %d.%ds",
-		  ssock->param.timeout.sec, ssock->param.timeout.msec));
-
-	on_handshake_complete(ssock, PJ_ETIMEDOUT);
-	break;
-    case TIMER_CLOSE:
-	pj_ssl_sock_close(ssock);
-	break;
-    default:
-	pj_assert(!"Unknown timer");
-	break;
-    }
+	SSL_set_connect_state(ossock->ossl_ssl);
+    }
+}
+
+
+static void ssl_set_peer_name(pj_ssl_sock_t *ssock)
+{
+#ifdef SSL_set_tlsext_host_name
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
+
+    /* Set server name to connect */
+    if (ssock->param.server_name.slen) {
+	/* Server name is null terminated already */
+	if (!SSL_set_tlsext_host_name(ossock->ossl_ssl, 
+				      ssock->param.server_name.ptr))
+	{
+	    char err_str[PJ_ERR_MSG_SIZE];
+
+	    ERR_error_string_n(ERR_get_error(), err_str, sizeof(err_str));
+	    PJ_LOG(3,(ssock->pool->obj_name, "SSL_set_tlsext_host_name() "
+		"failed: %s", err_str));
+	}
+    }
+#endif
 }
 
 
 /* Asynchronouse handshake */
-static pj_status_t do_handshake(pj_ssl_sock_t *ssock)
-{
+static pj_status_t ssl_do_handshake(pj_ssl_sock_t *ssock)
+{
+    ossl_sock_t *ossock = (ossl_sock_t *)ssock;
     pj_status_t status;
     int err;
@@ -2102,5 +1633,5 @@
     /* Perform SSL handshake */
     pj_lock_acquire(ssock->write_mutex);
-    err = SSL_do_handshake(ssock->ossl_ssl);
+    err = SSL_do_handshake(ossock->ossl_ssl);
     pj_lock_release(ssock->write_mutex);
 
@@ -2108,5 +1639,5 @@
      * flush it if any.
      */
-    status = flush_write_bio(ssock, &ssock->handshake_op_key, 0, 0);
+    status = flush_circ_buf_output(ssock, &ssock->handshake_op_key, 0, 0);
     if (status != PJ_SUCCESS && status != PJ_EPENDING) {
 	return status;
@@ -2114,5 +1645,5 @@
 
     if (err < 0) {
-	int err2 = SSL_get_error(ssock->ossl_ssl, err);
+	int err2 = SSL_get_error(ossock->ossl_ssl, err);
 	if (err2 != SSL_ERROR_NONE && err2 != SSL_ERROR_WANT_READ)
 	{
@@ -2124,5 +1655,5 @@
 
     /* Check if handshake has been completed */
-    if (SSL_is_init_finished(ssock->ossl_ssl)) {
+    if (SSL_is_init_finished(ossock->ossl_ssl)) {
 	ssock->ssl_state = SSL_STATE_ESTABLISHED;
 	return PJ_SUCCESS;
